##BASIC
execute if score Global Mass matches 1000..2147483647 if score Global Points matches 0..9 run function crimson_curse:phase_i
execute if score Global Mass matches 3000..2147483647 if score Global Points matches 10..29 run function crimson_curse:phase_ii
execute if score Global Mass matches 6000..2147483647 if score Global Points matches 30..59 run function crimson_curse:phase_iii
execute if score Global Mass matches 8000..2147483647 if score Global Points matches 60..99 run function crimson_curse:phase_iv
execute if score Global Mass matches 7000..2147483647 if score Global Points matches 100..2147483647 store result score Global Pod run random value 1..12
execute if score Global Points matches 100..2147483647 run function crimson_curse:phase_v
execute if score Global Pod matches 1..2147483647 run function crimson_curse:mass_threshold
execute if score Global Mass matches -2147483648..-1 run function crimson_curse:negative_mass

execute if score Second Mass matches 20..2147483647 run scoreboard players set Second Mass 0
scoreboard players add Second Mass 1

#________________________________________________________________________________________________________________________________________________________________________
##MOBS

##PLAYER STUFF
execute as @a at @s run function crimson_curse:player_passive

team join Allies @e[type=iron_golem,team=!Allies]
team join Allies @e[type=#crimson_curse:villagers,team=!Allies]
team join Allies @e[type=trader_llama,team=!Allies]
execute as @e[type=wither_skeleton] at @s run function crimson_curse:wither_skeletons
execute as @e[type=zombie] at @s run function crimson_curse:zombies
execute as @e[type=marker] at @s run function crimson_curse:markers
execute as @e[type=zombified_piglin] at @s run function crimson_curse:zombified_piglins
execute as @e[type=vex] at @s run function crimson_curse:vexes
execute as @e[type=creeper] at @s run function crimson_curse:creepers
execute as @e[type=item_display] at @s run function crimson_curse:item_displays
execute as @e[type=phantom] at @s run function crimson_curse:phantoms
execute as @e[type=armor_stand] at @s run function crimson_curse:armor_stands
execute as @e[team=Crimson_Invaders] at @s run function crimson_curse:crimson_invaders
execute as @e[type=#crimson_curse:infectable,team=!Crimson_Invaders] at @s run function crimson_curse:infectables

##Custom Sounds
execute at @a as @e[tag=Custom_Sound,distance=..25] at @s run function crimson_curse:custom_sound
execute at @a as @e[tag=Custom_Sound_Loud,distance=..100] at @s run function crimson_curse:custom_sound
execute as @e[scores={Ambient_Sound=1..200}] at @s run function crimson_curse:custom_sound_disable

##Bloodlink
execute unless entity @e[type=wither_skeleton,tag=Bloodlink] run scoreboard players add Start_Spawn Mass 1
execute unless score Global Mass matches -2147483648..2147483647 run scoreboard players add Global Mass 0
execute unless score Global Points matches -2147483648..2147483647 run scoreboard players add Global Points 0
execute unless score Node Mass matches -2147483648..2147483647 run scoreboard players add Node Mass 0
execute unless score Start_Spawn Points matches -2147483648..2147483647 run scoreboard players add Start_Spawn Points 0

execute if score Start_Spawn Mass matches 24000..2147483647 unless entity @e[type=wither_skeleton,tag=Bloodlink] at @r if dimension overworld at @e[limit=1,sort=random,distance=25..150] if block ^ ^ ^ air if block ^ ^1 ^ air if block ^ ^2 ^ air if block ^ ^10 ^ air if block ^ ^25 ^ air unless block ^ ^-0.01 ^ #replaceable run function crimson_curse:start_spawn

execute if score Start_Spawn Mass matches 1..2147483647 if entity @e[type=wither_skeleton,tag=Bloodlink] run scoreboard players reset Start_Spawn Mass

execute as @e[type=allay,tag=Bloodlink_Spore] at @s run function crimson_curse:bloodlink_spore

execute unless entity @e[type=wither_skeleton,tag=Bloodlink,tag=attack] run bossbar set bloodlink visible false

scoreboard players add Cap Transform_Timer 1
execute if score Cap Transform_Timer matches 1200..2147483647 run function crimson_curse:bloodlink_marker_reset


##Decayed Mobs
execute as @e[tag=Decayed] at @s run function crimson_curse:decayed_mob

##Crimsonified Mobs
execute as @e[type=zombie_villager,tag=Crimsonified_Villager] at @s run function crimson_curse:crimsonified_villager_passive
execute as @e[type=husk,tag=Crimsonified_Husk] at @s run function crimson_curse:crimsonified_husk_passive
execute as @e[type=skeleton,tag=Crimsonified_Skeleton] at @s run function crimson_curse:crimsonified_skeleton_passive

##Node
execute as @e[type=magma_cube,name=Node] at @s unless entity @e[type=marker,name=Node,distance=..1] run function crimson_curse:node
execute if entity @e[type=marker,tag=Node] run scoreboard players add Node Mass 1
execute if score Node Mass matches 60..2147483647 run scoreboard players set Node Mass 0

##Osiris
#2147483647
effect give @e[type=slime,tag=Osiris_Brain] invisibility infinite 0 true

##Pummeler
execute as @e[type=ghast,tag=Pummeler] at @s run function crimson_curse:pummeler_passive

#________________________________________________________________________________________________________________________________________________________________________
    ##PLACEABLE ITEMS

##Beacon Purifier
execute as @e[type=iron_golem,tag=Beacon_Purifier] at @s if loaded ~32 ~ ~ if loaded ~-32 ~ ~ if loaded ~ ~ ~32 if loaded ~ ~ ~-32 if block ~ ~-1 ~ beacon if block ~ ~-2 ~ #beacon_base_blocks if block ~1 ~-2 ~ #beacon_base_blocks if block ~-1 ~-2 ~ #beacon_base_blocks if block ~ ~-2 ~1 #beacon_base_blocks if block ~ ~-2 ~-1 #beacon_base_blocks if block ~1 ~-2 ~1 #beacon_base_blocks if block ~-1 ~-2 ~1 #beacon_base_blocks if block ~1 ~-2 ~-1 #beacon_base_blocks if block ~-1 ~-2 ~-1 #beacon_base_blocks unless entity @e[type=marker,tag=Beacon_Purifier,distance=..12] run function crimson_curse:beacon_purifier_activate

##Arrows (ALWAYS KEEP AT THE BOTTOM)
execute as @e[type=#arrows] at @s run function crimson_curse:arrows

tag @a[tag=Heavy_Hitting] remove Heavy_Hitting